unit StrEncoder;
{
2006.02.24.
Egy nagyon egyszer titkost a jogosult paramterlltk jelszavainak
trolshoz. A digits konstansban megadott karakterekkel 2 jegy szmokk
alaktja az ascii kdot. A nehezts kedvrt a kisebb helyi rtk szmjegy
van elszr trolva. Gyakorlatilag egy szmrendszer tvlt.
}
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
interface
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
  Function StrEncode(s:string):string; // kdol
  Function StrDecode(s:string):string; // dekdol
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
implementation
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
const
  digits= '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  Ldigits=Length(digits);
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
Function StrEncode(s:string):string;
var
  i,j: Integer;
  ch:byte;
begin
  result:='';
  if s<>'' then
  begin
    for i:=1 to length(s) do
    begin
      ch:=ord(s[i]);
      for j:=1 to 2 do
      begin
        result:=result+digits[(ch mod Ldigits)+1];
        ch:=ch div Ldigits;
      end;
    end;
  end;
end;
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
Function StrDecode(s:string):string;
var
  i: Integer;
  hi,lo:byte;
begin
  result:='';
  lo:=0;
  if s<>'' then
  begin
    for i:=1 to length(s) do
    begin
      if (i and 1)=1 then
      begin
        lo:=pos(s[i],digits)
      end else
      begin
        hi:=pos(s[i],digits);
        if (hi>0) and (lo>0) then
        begin
          result:=result+chr((hi-1)*Ldigits+(lo-1));
        end;
      end;
    end;
  end;
end;
//-----------?-----------?-----------?-----------?-----------?-----------?-----------?-
end.
